/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2004 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_UTILITIES_H__54F0E0FB_ABA1_4BDC_9F6B_8DF661DA0BD2__INCLUDED_)
#define AFX_UTILITIES_H__54F0E0FB_ABA1_4BDC_9F6B_8DF661DA0BD2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

const int MAX_INTEGER = 5000;
const int MIN_INTEGER = -5000;

#define OS_9X   0x0001
#define OS_NT   0x0002
#define OS_95   0x0004
#define OS_98   0x0008
#define OS_ME   0x0010
#define OS_NT4  0x0020
#define OS_2K   0x0040
#define OS_XP   0x0080
#define OS_2KXP 0x0100

#define StringCchCopy(a, b, c) strncpy((a), (c), (b))
#define StringCchLength(a, b, c) *(c) = strlen((a)), S_OK
#define StringCchPrintf _snprintf

enum
{
	MULTIBLT_STRETCH,
	MULTIBLT_TILE,
	MULTIBLT_TILEHORIZONTAL,
	MULTIBLT_TILEVERTICAL
};

struct NameValuePair
{
	const char *name;
	int value;
};

// Find windows at any level (not only top level windows)
struct FindWindowEx2Data
{
	LPCSTR pszClass;
	LPCSTR pszTitle;
	HWND *phWnd;
};

string GetTaskClass( HWND hTask );

string GetTaskWindowText( HWND hTask );

string GetTaskFileName( HWND hTask );

void PrefixedLSSetVariable(string prefix, string var, string value);

vector<string> split(string str, string sep);

bool IsSubString(string big, string small);

bool IsOnTaskbarList(HWND hWnd, vector<string> theList, bool emptyValue);

void GetTaskIcon(HWND hTask, HICON &hIcon, bool bBigIcon);

bool GetIconOnCustomList(HWND hWnd, HICON &hIcon, vector<string> theList, bool bBigIcon);

bool IsOS(const int &os);

string QueryPixelDepth();

HWND GetLitestepDesktop();

HWND FindWindowEx2(string pszClass, string pszTitle);
static BOOL CALLBACK FindWindowEx2EnumWindowsProc(HWND hWnd, LPARAM lParam);

bool IsAppWindow(const HWND &hWnd);
bool IsValidWindow(const HWND &hWnd, const bool &VWMCurrentDesktopOnly);

void ModifyStyle(HWND hWnd, DWORD removeStyle, DWORD addStyle);
void ModifyStyleEx(HWND hWnd, DWORD removeStyle, DWORD addStyle);

string trim(const string &toTrim);

void GetxRCList(char *text, vector<string> &theList, bool trim);

bool GetxRCBool(const string &prefix, const string &baseName, bool defaultVal = false);

string GetxRCString(const string &prefix, const string &baseName, const string &defaultVal);

string GetxRCLine(const string &prefix, const string &baseName, const string &defaultVal);

int GetxRCNamedValue(const string &prefix, const string &baseName, const NameValuePair *nameValuePairs, int defaultVal);

int GetxRCColor(const string &prefix, const string &baseName, int defaultVal);

int GetxRCInt(const string &prefix, const string &baseName, int defaultVal, int minVal = MIN_INTEGER, int maxVal = MAX_INTEGER);

int xParseCoord(const string &aString, int defaultVal, int maxVal);
int GetxRCCoord(const string &prefix, const string &baseName, int defaultVal, int maxVal);

int xParseDimen(const string &aString, int defaultVal, int maxVal);
int GetxRCDimen(const string &prefix, const string &baseName, int defaultVal, int maxVal);

void PaintDesktopEx(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, int xSrc, int ySrc, BOOL updateCache);

void TileBlt(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, DWORD rasterOp);
void HorizontalTileBlt(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, DWORD rasterOp);
void VerticalTileBlt(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, DWORD rasterOp);
void MultiBlt(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, int cxLeft, int cyTop, int cxRight, int cyBottom, int mode, DWORD rasterOp);

LPTSTR RegQueryStringValue(HKEY hKey, LPCTSTR pszSubKey, LPCTSTR pszValueName, LPTSTR pszBuffer, int nBufferSize, LPTSTR pszDefaultValue);

string IntToString(int input);

#endif // !defined(AFX_UTILITIES_H__54F0E0FB_ABA1_4BDC_9F6B_8DF661DA0BD2__INCLUDED_)
